/*
*
* CwBdVouchtempcomExample.java
* Copyright(C) 2017-2020 DHCC
* @date 2019-04-05
*/
package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwBdVouchtempcomExample {

	protected String orderByClause;
	protected boolean distinct;
	protected List<Criteria> oredCriteria;

	public CwBdVouchtempcomExample() {
		oredCriteria = new ArrayList<Criteria>();
	}

	public void setOrderByClause(String orderByClause) {
		this.orderByClause = orderByClause;
	}

	public String getOrderByClause() {
		return orderByClause;
	}

	public void setDistinct(boolean distinct) {
		this.distinct = distinct;
	}

	public boolean isDistinct() {
		return distinct;
	}

	public List<Criteria> getOredCriteria() {
		return oredCriteria;
	}

	public void or(Criteria criteria) {
		oredCriteria.add(criteria);
	}

	public Criteria or() {
		Criteria criteria = createCriteriaInternal();
		oredCriteria.add(criteria);
		return criteria;
	}

	public Criteria createCriteria() {
		Criteria criteria = createCriteriaInternal();
		if (oredCriteria.size() == 0) {
			oredCriteria.add(criteria);
		}
		return criteria;
	}

	protected Criteria createCriteriaInternal() {
		Criteria criteria = new Criteria();
		return criteria;
	}

	public void clear() {
		oredCriteria.clear();
		orderByClause = null;
		distinct = false;
	}

	protected abstract static class GeneratedCriteria {
		protected List<Criterion> criteria;

		protected GeneratedCriteria() {
			super();
			criteria = new ArrayList<Criterion>();
		}

		public boolean isValid() {
			return criteria.size() > 0;
		}

		public List<Criterion> getAllCriteria() {
			return criteria;
		}

		public List<Criterion> getCriteria() {
			return criteria;
		}

		protected void addCriterion(String condition) {
			if (condition == null) {
				throw new RuntimeException("Value for condition cannot be null");
			}
			criteria.add(new Criterion(condition));
		}

		protected void addCriterion(String condition, Object value, String property) {
			if (value == null) {
				throw new RuntimeException("Value for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value));
		}

		protected void addCriterion(String condition, Object value1, Object value2, String property) {
			if (value1 == null || value2 == null) {
				throw new RuntimeException("Between values for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value1, value2));
		}

		public Criteria andPkVouchtempcomIsNull() {
			addCriterion("PK_VOUCHTEMPCOM is null");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomIsNotNull() {
			addCriterion("PK_VOUCHTEMPCOM is not null");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomEqualTo(String value) {
			addCriterion("PK_VOUCHTEMPCOM =", value, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomNotEqualTo(String value) {
			addCriterion("PK_VOUCHTEMPCOM <>", value, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomGreaterThan(String value) {
			addCriterion("PK_VOUCHTEMPCOM >", value, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomGreaterThanOrEqualTo(String value) {
			addCriterion("PK_VOUCHTEMPCOM >=", value, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomLessThan(String value) {
			addCriterion("PK_VOUCHTEMPCOM <", value, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomLessThanOrEqualTo(String value) {
			addCriterion("PK_VOUCHTEMPCOM <=", value, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomLike(String value) {
			addCriterion("PK_VOUCHTEMPCOM like", value, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomNotLike(String value) {
			addCriterion("PK_VOUCHTEMPCOM not like", value, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomIn(List<String> values) {
			addCriterion("PK_VOUCHTEMPCOM in", values, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomNotIn(List<String> values) {
			addCriterion("PK_VOUCHTEMPCOM not in", values, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomBetween(String value1, String value2) {
			addCriterion("PK_VOUCHTEMPCOM between", value1, value2, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempcomNotBetween(String value1, String value2) {
			addCriterion("PK_VOUCHTEMPCOM not between", value1, value2, "pkVouchtempcom");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeIsNull() {
			addCriterion("PK_BILLTYPE is null");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeIsNotNull() {
			addCriterion("PK_BILLTYPE is not null");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeEqualTo(String value) {
			addCriterion("PK_BILLTYPE =", value, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeNotEqualTo(String value) {
			addCriterion("PK_BILLTYPE <>", value, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeGreaterThan(String value) {
			addCriterion("PK_BILLTYPE >", value, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeGreaterThanOrEqualTo(String value) {
			addCriterion("PK_BILLTYPE >=", value, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeLessThan(String value) {
			addCriterion("PK_BILLTYPE <", value, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeLessThanOrEqualTo(String value) {
			addCriterion("PK_BILLTYPE <=", value, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeLike(String value) {
			addCriterion("PK_BILLTYPE like", value, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeNotLike(String value) {
			addCriterion("PK_BILLTYPE not like", value, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeIn(List<String> values) {
			addCriterion("PK_BILLTYPE in", values, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeNotIn(List<String> values) {
			addCriterion("PK_BILLTYPE not in", values, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeBetween(String value1, String value2) {
			addCriterion("PK_BILLTYPE between", value1, value2, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andPkBilltypeNotBetween(String value1, String value2) {
			addCriterion("PK_BILLTYPE not between", value1, value2, "pkBilltype");
			return (Criteria) this;
		}

		public Criteria andTransnameIsNull() {
			addCriterion("TRANSNAME is null");
			return (Criteria) this;
		}

		public Criteria andTransnameIsNotNull() {
			addCriterion("TRANSNAME is not null");
			return (Criteria) this;
		}

		public Criteria andTransnameEqualTo(String value) {
			addCriterion("TRANSNAME =", value, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameNotEqualTo(String value) {
			addCriterion("TRANSNAME <>", value, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameGreaterThan(String value) {
			addCriterion("TRANSNAME >", value, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameGreaterThanOrEqualTo(String value) {
			addCriterion("TRANSNAME >=", value, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameLessThan(String value) {
			addCriterion("TRANSNAME <", value, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameLessThanOrEqualTo(String value) {
			addCriterion("TRANSNAME <=", value, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameLike(String value) {
			addCriterion("TRANSNAME like", value, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameNotLike(String value) {
			addCriterion("TRANSNAME not like", value, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameIn(List<String> values) {
			addCriterion("TRANSNAME in", values, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameNotIn(List<String> values) {
			addCriterion("TRANSNAME not in", values, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameBetween(String value1, String value2) {
			addCriterion("TRANSNAME between", value1, value2, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnameNotBetween(String value1, String value2) {
			addCriterion("TRANSNAME not between", value1, value2, "transname");
			return (Criteria) this;
		}

		public Criteria andTransnoIsNull() {
			addCriterion("TRANSNO is null");
			return (Criteria) this;
		}

		public Criteria andTransnoIsNotNull() {
			addCriterion("TRANSNO is not null");
			return (Criteria) this;
		}

		public Criteria andTransnoEqualTo(String value) {
			addCriterion("TRANSNO =", value, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoNotEqualTo(String value) {
			addCriterion("TRANSNO <>", value, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoGreaterThan(String value) {
			addCriterion("TRANSNO >", value, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoGreaterThanOrEqualTo(String value) {
			addCriterion("TRANSNO >=", value, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoLessThan(String value) {
			addCriterion("TRANSNO <", value, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoLessThanOrEqualTo(String value) {
			addCriterion("TRANSNO <=", value, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoLike(String value) {
			addCriterion("TRANSNO like", value, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoNotLike(String value) {
			addCriterion("TRANSNO not like", value, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoIn(List<String> values) {
			addCriterion("TRANSNO in", values, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoNotIn(List<String> values) {
			addCriterion("TRANSNO not in", values, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoBetween(String value1, String value2) {
			addCriterion("TRANSNO between", value1, value2, "transno");
			return (Criteria) this;
		}

		public Criteria andTransnoNotBetween(String value1, String value2) {
			addCriterion("TRANSNO not between", value1, value2, "transno");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempIsNull() {
			addCriterion("PK_VOUCHTEMP is null");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempIsNotNull() {
			addCriterion("PK_VOUCHTEMP is not null");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempEqualTo(String value) {
			addCriterion("PK_VOUCHTEMP =", value, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempNotEqualTo(String value) {
			addCriterion("PK_VOUCHTEMP <>", value, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempGreaterThan(String value) {
			addCriterion("PK_VOUCHTEMP >", value, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempGreaterThanOrEqualTo(String value) {
			addCriterion("PK_VOUCHTEMP >=", value, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempLessThan(String value) {
			addCriterion("PK_VOUCHTEMP <", value, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempLessThanOrEqualTo(String value) {
			addCriterion("PK_VOUCHTEMP <=", value, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempLike(String value) {
			addCriterion("PK_VOUCHTEMP like", value, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempNotLike(String value) {
			addCriterion("PK_VOUCHTEMP not like", value, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempIn(List<String> values) {
			addCriterion("PK_VOUCHTEMP in", values, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempNotIn(List<String> values) {
			addCriterion("PK_VOUCHTEMP not in", values, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempBetween(String value1, String value2) {
			addCriterion("PK_VOUCHTEMP between", value1, value2, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andPkVouchtempNotBetween(String value1, String value2) {
			addCriterion("PK_VOUCHTEMP not between", value1, value2, "pkVouchtemp");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameIsNull() {
			addCriterion("VOUCHTEMPNAME is null");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameIsNotNull() {
			addCriterion("VOUCHTEMPNAME is not null");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameEqualTo(String value) {
			addCriterion("VOUCHTEMPNAME =", value, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameNotEqualTo(String value) {
			addCriterion("VOUCHTEMPNAME <>", value, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameGreaterThan(String value) {
			addCriterion("VOUCHTEMPNAME >", value, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameGreaterThanOrEqualTo(String value) {
			addCriterion("VOUCHTEMPNAME >=", value, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameLessThan(String value) {
			addCriterion("VOUCHTEMPNAME <", value, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameLessThanOrEqualTo(String value) {
			addCriterion("VOUCHTEMPNAME <=", value, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameLike(String value) {
			addCriterion("VOUCHTEMPNAME like", value, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameNotLike(String value) {
			addCriterion("VOUCHTEMPNAME not like", value, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameIn(List<String> values) {
			addCriterion("VOUCHTEMPNAME in", values, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameNotIn(List<String> values) {
			addCriterion("VOUCHTEMPNAME not in", values, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameBetween(String value1, String value2) {
			addCriterion("VOUCHTEMPNAME between", value1, value2, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andVouchtempnameNotBetween(String value1, String value2) {
			addCriterion("VOUCHTEMPNAME not between", value1, value2, "vouchtempname");
			return (Criteria) this;
		}

		public Criteria andUseStateIsNull() {
			addCriterion("USE_STATE is null");
			return (Criteria) this;
		}

		public Criteria andUseStateIsNotNull() {
			addCriterion("USE_STATE is not null");
			return (Criteria) this;
		}

		public Criteria andUseStateEqualTo(String value) {
			addCriterion("USE_STATE =", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateNotEqualTo(String value) {
			addCriterion("USE_STATE <>", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateGreaterThan(String value) {
			addCriterion("USE_STATE >", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateGreaterThanOrEqualTo(String value) {
			addCriterion("USE_STATE >=", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateLessThan(String value) {
			addCriterion("USE_STATE <", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateLessThanOrEqualTo(String value) {
			addCriterion("USE_STATE <=", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateLike(String value) {
			addCriterion("USE_STATE like", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateNotLike(String value) {
			addCriterion("USE_STATE not like", value, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateIn(List<String> values) {
			addCriterion("USE_STATE in", values, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateNotIn(List<String> values) {
			addCriterion("USE_STATE not in", values, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateBetween(String value1, String value2) {
			addCriterion("USE_STATE between", value1, value2, "useState");
			return (Criteria) this;
		}

		public Criteria andUseStateNotBetween(String value1, String value2) {
			addCriterion("USE_STATE not between", value1, value2, "useState");
			return (Criteria) this;
		}

		public Criteria andCreateUserIsNull() {
			addCriterion("CREATE_USER is null");
			return (Criteria) this;
		}

		public Criteria andCreateUserIsNotNull() {
			addCriterion("CREATE_USER is not null");
			return (Criteria) this;
		}

		public Criteria andCreateUserEqualTo(String value) {
			addCriterion("CREATE_USER =", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserNotEqualTo(String value) {
			addCriterion("CREATE_USER <>", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserGreaterThan(String value) {
			addCriterion("CREATE_USER >", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
			addCriterion("CREATE_USER >=", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserLessThan(String value) {
			addCriterion("CREATE_USER <", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserLessThanOrEqualTo(String value) {
			addCriterion("CREATE_USER <=", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserLike(String value) {
			addCriterion("CREATE_USER like", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserNotLike(String value) {
			addCriterion("CREATE_USER not like", value, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserIn(List<String> values) {
			addCriterion("CREATE_USER in", values, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserNotIn(List<String> values) {
			addCriterion("CREATE_USER not in", values, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserBetween(String value1, String value2) {
			addCriterion("CREATE_USER between", value1, value2, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateUserNotBetween(String value1, String value2) {
			addCriterion("CREATE_USER not between", value1, value2, "createUser");
			return (Criteria) this;
		}

		public Criteria andCreateTimeIsNull() {
			addCriterion("CREATE_TIME is null");
			return (Criteria) this;
		}

		public Criteria andCreateTimeIsNotNull() {
			addCriterion("CREATE_TIME is not null");
			return (Criteria) this;
		}

		public Criteria andCreateTimeEqualTo(Date value) {
			addCriterion("CREATE_TIME =", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeNotEqualTo(Date value) {
			addCriterion("CREATE_TIME <>", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeGreaterThan(Date value) {
			addCriterion("CREATE_TIME >", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
			addCriterion("CREATE_TIME >=", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeLessThan(Date value) {
			addCriterion("CREATE_TIME <", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
			addCriterion("CREATE_TIME <=", value, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeIn(List<Date> values) {
			addCriterion("CREATE_TIME in", values, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeNotIn(List<Date> values) {
			addCriterion("CREATE_TIME not in", values, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeBetween(Date value1, Date value2) {
			addCriterion("CREATE_TIME between", value1, value2, "createTime");
			return (Criteria) this;
		}

		public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
			addCriterion("CREATE_TIME not between", value1, value2, "createTime");
			return (Criteria) this;
		}

		public Criteria andUpdateUserIsNull() {
			addCriterion("UPDATE_USER is null");
			return (Criteria) this;
		}

		public Criteria andUpdateUserIsNotNull() {
			addCriterion("UPDATE_USER is not null");
			return (Criteria) this;
		}

		public Criteria andUpdateUserEqualTo(String value) {
			addCriterion("UPDATE_USER =", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserNotEqualTo(String value) {
			addCriterion("UPDATE_USER <>", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserGreaterThan(String value) {
			addCriterion("UPDATE_USER >", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
			addCriterion("UPDATE_USER >=", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserLessThan(String value) {
			addCriterion("UPDATE_USER <", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserLessThanOrEqualTo(String value) {
			addCriterion("UPDATE_USER <=", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserLike(String value) {
			addCriterion("UPDATE_USER like", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserNotLike(String value) {
			addCriterion("UPDATE_USER not like", value, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserIn(List<String> values) {
			addCriterion("UPDATE_USER in", values, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserNotIn(List<String> values) {
			addCriterion("UPDATE_USER not in", values, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserBetween(String value1, String value2) {
			addCriterion("UPDATE_USER between", value1, value2, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateUserNotBetween(String value1, String value2) {
			addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeIsNull() {
			addCriterion("UPDATE_TIME is null");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeIsNotNull() {
			addCriterion("UPDATE_TIME is not null");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeEqualTo(Date value) {
			addCriterion("UPDATE_TIME =", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeNotEqualTo(Date value) {
			addCriterion("UPDATE_TIME <>", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeGreaterThan(Date value) {
			addCriterion("UPDATE_TIME >", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
			addCriterion("UPDATE_TIME >=", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeLessThan(Date value) {
			addCriterion("UPDATE_TIME <", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
			addCriterion("UPDATE_TIME <=", value, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeIn(List<Date> values) {
			addCriterion("UPDATE_TIME in", values, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeNotIn(List<Date> values) {
			addCriterion("UPDATE_TIME not in", values, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeBetween(Date value1, Date value2) {
			addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
			return (Criteria) this;
		}

		public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
			addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
			return (Criteria) this;
		}

		public Criteria andRemarkIsNull() {
			addCriterion("REMARK is null");
			return (Criteria) this;
		}

		public Criteria andRemarkIsNotNull() {
			addCriterion("REMARK is not null");
			return (Criteria) this;
		}

		public Criteria andRemarkEqualTo(String value) {
			addCriterion("REMARK =", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkNotEqualTo(String value) {
			addCriterion("REMARK <>", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkGreaterThan(String value) {
			addCriterion("REMARK >", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkGreaterThanOrEqualTo(String value) {
			addCriterion("REMARK >=", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkLessThan(String value) {
			addCriterion("REMARK <", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkLessThanOrEqualTo(String value) {
			addCriterion("REMARK <=", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkLike(String value) {
			addCriterion("REMARK like", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkNotLike(String value) {
			addCriterion("REMARK not like", value, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkIn(List<String> values) {
			addCriterion("REMARK in", values, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkNotIn(List<String> values) {
			addCriterion("REMARK not in", values, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkBetween(String value1, String value2) {
			addCriterion("REMARK between", value1, value2, "remark");
			return (Criteria) this;
		}

		public Criteria andRemarkNotBetween(String value1, String value2) {
			addCriterion("REMARK not between", value1, value2, "remark");
			return (Criteria) this;
		}
	}

	public static class Criteria extends GeneratedCriteria {
		protected Criteria() {
			super();
		}
	}

	public static class Criterion {
		private String condition;
		private Object value;
		private Object secondValue;
		private boolean noValue;
		private boolean singleValue;
		private boolean betweenValue;
		private boolean listValue;
		private String typeHandler;

		public String getCondition() {
			return condition;
		}

		public Object getValue() {
			return value;
		}

		public Object getSecondValue() {
			return secondValue;
		}

		public boolean isNoValue() {
			return noValue;
		}

		public boolean isSingleValue() {
			return singleValue;
		}

		public boolean isBetweenValue() {
			return betweenValue;
		}

		public boolean isListValue() {
			return listValue;
		}

		public String getTypeHandler() {
			return typeHandler;
		}

		protected Criterion(String condition) {
			super();
			this.condition = condition;
			this.typeHandler = null;
			this.noValue = true;
		}

		protected Criterion(String condition, Object value, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.typeHandler = typeHandler;
			if (value instanceof List<?>) {
				this.listValue = true;
			} else {
				this.singleValue = true;
			}
		}

		protected Criterion(String condition, Object value) {
			this(condition, value, null);
		}

		protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.secondValue = secondValue;
			this.typeHandler = typeHandler;
			this.betweenValue = true;
		}

		protected Criterion(String condition, Object value, Object secondValue) {
			this(condition, value, secondValue, null);
		}
	}


   
}